/*********************************************************************
 * Sequence process for Desktop Station main
 *
 * Copyright (C) 2015 Yaasan
 *
 */

#include <Arduino.h>


#define SQBUTTON_FNC 0b00000001
#define SQBUTTON_ENT 0b00000010
#define SQBUTTON_ESC 0b00000100
#define SQBUTTON_UP	 0b00001000
#define SQBUTTON_DN	 0b00010000
#define SQBUTTON_DIR 0b00100000
#define SQBUTTON_RUN 0b01000000


#define POWER_ON 1
#define POWER_OFF 0


typedef void (*CVFunction) (const byte inSeq, const word inCVAddr, const byte inCVValue);
typedef void (*VoidFunction) ();
typedef void (*PowerFunction) (const byte inPower);
typedef void (*AddrFunction) (const word inAddr, const byte inDir, const long inFuncBuf);
typedef void (*SpeedFunction) (const word inAddr, const word inSpeed, const bool inUpdate);
typedef void (*DirFunction) (const word inAddr, const byte inDir, const bool inUpdate);
typedef void (*FuncFunction) (const word inAddr, const byte inFuncNo, const byte inFuncPower, const bool inUpdate, const byte inMode, const long inFuncBuf);


class DSSequence {

  private:
	
	
	
	//Function buffer
	
	byte getButtonStatus();
	word getDialStatus();
	byte GetButtonsFromAD(unsigned short inADData);
	word ProcessCheck( word inTemp);

	
	
  public:
	word gButtonStatus = 0;
	
	
	DSSequence();
	void Init();
	bool Interval();

};
